#!/usr/bin/python
#-*- coding: utf-8 -*-
'''
retrieveのサンプル（画像データ）スクリプト

データを取り出し、画像を表示する。 Grayscaleのみ

$ python SampleImage.py diag shot subshot channel frame
 or
$ SampleImage.py diag shot subshot channel frame

e.g)
$ SampleImage.py ECH_2Occd 110000 1 1 100


[ source code ]

import sys
from labcom.Retriever import Retriever,RetrieveError 

if __name__ == '__main__' :
    import matplotlib.pyplot as mpimg
    
    argvs = sys.argv
    argc = len(argvs)
    if( argc != 6 ) :
        print 'Usage: %s diag shot subshot channel frame' % argvs[0]
        print ' or '
        print 'Usage: pyhton %s diag shot subshot channel frame' % argvs[0]
        print ' on python '
        sys.exit(0)

    print 'SampleImage START'
    print Retriever.version()
    
    try:
        p = Retriever()
        arc = p.get_frames( argvs[1], int(argvs[2]), int(argvs[3]), int(argvs[4]), int(argvs[5]))
        fidx = 0
        ary= arc.val()
        print ary.dtype
        print ary.ndim
        print ary.shape
        print arc.parameters
        imgplot=mpimg.imshow(ary[fidx,:,:],cmap = mpimg.get_cmap('gray'))
	mpimg.xticks([]), mpimg.yticks([])
        mpimg.show()
    except RetrieveError, e:
        print 'Retrieve Error : ', e.func,e.msg,e.code 

    print 'SampleImage END'

'''
#
__version__ = '22.0.0'
__date__ = '2020-07-31'

import sys
from labcom.Retriever import Retriever,RetrieveError 

if __name__ == '__main__' :
    import matplotlib.pyplot as mpimg
    import optparse
    print sys.version
    
    parser = optparse.OptionParser(usage='%prog [options] diag shot subshot channel frame', version=__version__)
    g2opt = optparse.OptionGroup(parser,'Direct options','for direct connection.')
    g2opt.add_option('--host', action='store', dest='host_opt',help='Connection destination host name')
    g2opt.add_option('--path', action='store', dest='path_opt',help='Connection destination path name')

    parser.add_option_group(g2opt)
 
    argopt, arg_remainder = parser.parse_args()
    argvs= arg_remainder
    argc = len(argvs)
    
    if( argc != 5 ) :
        parser.print_help()
        sys.exit(0)

    host_opt = argopt.host_opt
    path_opt = argopt.path_opt
    if None != argopt.host_opt :
        if None == argopt.path_opt :
            path_opt = 'ShotDataFS'

    print 'SampleImage.py START'
    print Retriever.version()
    
    try:
        p = Retriever(0, host_opt, path_opt,0 )
    #    arc = p.get("ECH_2Occd",112000,1,1)
    #    fidx = 49
    #    arc = p.get("ECH_2Occd",110000,1,1)
    #    fidx = 100
        arc = p.get_frames( argvs[0], int(argvs[1]), int(argvs[2]), int(argvs[3]), int(argvs[4]))
        fidx = 0
        image_type = arc.parameters['ImageType']
        print image_type
        if (image_type == 'YUV422') or (image_type == 'YUY2') :
            ary= arc.converted_rgb()
            mpimg.imshow(ary[fidx,:,:,:])
        else :
            ary= arc.val()
            print ary.dtype
            print ary.ndim
            print ary.shape
            print arc.parameters
            mpimg.imshow(ary[fidx,:,:],cmap = mpimg.get_cmap('gray'))

        mpimg.xticks([]), mpimg.yticks([])
        mpimg.show()
    except RetrieveError, e:
        print 'Retrieve Error : ', e.msg,' (',e.func,':',e.code,')' 

    print 'SampleImage.py END'
    
