from distutils.core import setup, Extension
#from setuptools import setup, Extension
# platform.machine() = i686| x86_64| x86| AMD64
# platform.system()  =        Linux| Windows
#
import os,platform
labcom_dir = os.getenv("Retrieve")
if labcom_dir == None :
	labcom_dir = "/usr/labcom"

if platform.machine().find('64' ) != -1 :
	if platform.system().find('Windows') != -1 :
		RETRIEVE_LIB_DIR=labcom_dir+'/win_sdk/lib64'
		RETRIEVE_INC_DIR=labcom_dir+'/win_sdk/include'
		LIB_RETRIEVE='Retrieve'
		LIB_DBSTORE='dbstoredll'
		ext_macros = [('WIN32',None),('WIN64',None)]
		src_scripts=['labcom/SamplePlot.py','labcom/SampleDBstore.py','labcom/SampleImage.py',
	         'scripts/SamplePlot.cmd','scripts/SampleDBstore.cmd','scripts/SampleImage.cmd']
		retrieve_sources = ["src/retrieve_sjis_py.cpp"]
		dbstore_sources = ["src/dbstore_sjis_py.cpp"]
	else :
		RETRIEVE_LIB_DIR=labcom_dir+'/bin64'
		RETRIEVE_INC_DIR=labcom_dir+'/include'
		LIB_RETRIEVE='retrieve'
		LIB_DBSTORE='dbstore'
		ext_macros = []
		src_scripts=['labcom/SamplePlot.py','labcom/SampleDBstore.py','labcom/SampleImage.py']
		retrieve_sources = ["src/retrieve_py.cpp"]
		dbstore_sources = ["src/dbstore_py.cpp"]
else :
	if platform.system().find('Windows') != -1 :
		RETRIEVE_LIB_DIR=labcom_dir+'/win_sdk/lib'
		RETRIEVE_INC_DIR=labcom_dir+'/win_sdk/include'
		LIB_RETRIEVE='Retrieve'
		LIB_DBSTORE='dbstoredll'
		ext_macros = [('WIN32',None)]
		src_scripts=['labcom/SamplePlot.py','labcom/SampleDBstore.py','labcom/SampleImage.py',
	         'scripts/SamplePlot.cmd','scripts/SampleDBstore.cmd','scripts/SampleImage.cmd']
		retrieve_sources = ["src/retrieve_sjis_py.cpp"]
		dbstore_sources = ["src/dbstore_sjis_py.cpp"]
	else :
		RETRIEVE_LIB_DIR=labcom_dir+'/bin'
		RETRIEVE_INC_DIR=labcom_dir+'/include'
		LIB_RETRIEVE='retrieve'
		LIB_DBSTORE='dbstore'
		ext_macros = []
		src_scripts=['labcom/SamplePlot.py','labcom/SampleDBstore.py','labcom/SampleImage.py']
		retrieve_sources = ["src/retrieve_py.cpp"]
		dbstore_sources = ["src/dbstore_py.cpp"]

if not os.path.exists(RETRIEVE_INC_DIR+'/retrieve.h') :
	raise IOError('Not found retrieve.h')

setup(
	classifiers=[
		# How mature is this project? Common values are
		#   3 - Alpha
		#   4 - Beta
		#   5 - Production/Stable
		'Development Status :: 5 - Production/Stable',
		# Specify the Python versions you support here. In particular, ensure
		# that you indicate whether you support Python 2, Python 3 or both.
		'Programming Language :: Python :: 3',
		'Programming Language :: Python :: 3.5',
		'Programming Language :: Python :: 3.7',
		'Programming Language :: Python :: 3.8',
	],
	name="labcom-retrieve-py3",
	version="22.0.1",
	description="Python binding to LABCOM retrieve and dbstore",
	python_requires='>=3.5, <4',
	packages=['labcom'],
	install_requires=['numpy>=1.5.0'],
	scripts=src_scripts,
	py_modules=['labcom/Retriever','labcom/DBstorer','labcom/ArcData'],
	ext_modules=[
		Extension("labcom._retrieve",
			sources = retrieve_sources,
			define_macros = ext_macros,
			include_dirs = [RETRIEVE_INC_DIR],
			library_dirs = [RETRIEVE_LIB_DIR],
			libraries=[LIB_RETRIEVE]),
		Extension("labcom._dbstore",
			sources = dbstore_sources,
			define_macros = ext_macros,
			include_dirs = [RETRIEVE_INC_DIR],
			library_dirs = [RETRIEVE_LIB_DIR],
			libraries=[LIB_DBSTORE])],

)
