function   name_type = mParamType__Name(paramtype_classname)
% Convert code of retrieve's parameter type or class name.
%   name_type = mParamType__Name( paramtype_classname )
%
%       If paramtype_classname is numeric , it is paramtype. and convert to
%       class name.
%       If paramtype_classname is text(char), it is classname. and convert
%       to param type of retrieve.
%
%  Last upadte 2012-05-11

if isnumeric( paramtype_classname )
    switch paramtype_classname
        case 1  % string
            name_type = 'char';
        case 2  % 8bit integer
            name_type = 'int8';
        case 3  % 16bit integer
            name_type = 'int16';
        case 4  % 32bit integer
            name_type = 'int32';
        case 5  % 32bit float
            name_type = 'single';
        case 6  % 64bit double
            name_type = 'double';
        case 7  % 64bit integer
            name_type = 'int64';
        otherwise
            name_type = 'undefined';
    end
elseif ischar(paramtype_classname)
    switch paramtype_classname
        case 'char'
            name_type = int32(1);
        case {'int8' 'uint8'}
            name_type = int32(2);
        case {'int16' 'uint16'}
            name_type = int32(3);
        case {'int32' 'uint32'}
            name_type = int32(4);
        case {'single'}
            name_type = int32(5);
        case {'double'}
            name_type = int32(6);
        case {'int64' 'uint64'}
            name_type = int32(7);
        otherwise
            name_type = int32(0);
    end    
else
    name_type = 'undefined';
    return;
end
end