// This file is released under the 3-clause BSD license. See COPYING-BSD.
//
function builder_gw_cpp()

  files =[ 'sci_dbsOpen.cpp','sci_dbsClose.cpp','sci_dbsAbort.cpp','sci_dbsWrite.cpp', ..
           'sci_dbsOpenFrame.cpp','sci_dbsWriteFrame.cpp','sci_dbsWriteFrames.cpp','sci_dbsCloseFrame.cpp', ..
           'sci_dbstoreVersion.cpp','sci_dbsMessage.cpp','dbstore_err_message.cpp', ..
           'sci_currentSite.cpp','sci_changeSite.cpp', ..
           'sci_retrieveOpen.cpp','sci_retrieveShotInfo.cpp','sci_retrieveClose.cpp', ..
           'sci_retrieveChParam.cpp','sci_retrieveChParams.cpp','sci_retrieveChV.cpp','sci_retrieveChData.cpp', ..
           'sci_retrieveChInfo.cpp','sci_retrieveChInfo2.cpp','sci_retrieveRetrieveNo.cpp', ..
           'sci_retrieveChFrameData.cpp','sci_retrieveFrameData.cpp','sci_retrieveFrameInfo.cpp', ..
           'sci_retrieveTimeInfo.cpp','sci_retrieveTimeData.cpp','sci_retrieveGetDTSinfoFromRetrieve_ex.cpp', ..
           'sci_retrieveGetDTSParametersCount.cpp','sci_retrieveGetDTSParameters.cpp', ..
           'sci_retrieveGetDTSinfox.cpp','sci_retrieveGetDTSdatax2_ex.cpp', ..
           'sci_retrieveVersion.cpp', 'sci_retrieveMessage.cpp', 'sci_var2str.cpp', 'sci_str2var.cpp', 'retrieve_err_message.cpp', ..
           'get_var_boolean6.cpp','get_row_var_convert6.cpp','sci_retVarString.cpp', ..
           'get_var_convert6.cpp','get_var_string6.cpp','MatrixValues6.cpp','ParametersObj6.cpp'];

  funcs =[ 'dbsOpen',       'sci_dbsOpen',        'csci6'; 'dbsClose',     'sci_dbsClose',     'csci6'; ..
           'dbsAbort',      'sci_dbsAbort',       'csci6'; 'dbsWrite',     'sci_dbsWrite',     'csci6'; ..
           'dbsOpenFrame',  'sci_dbsOpenFrame',   'csci6'; 'dbsWriteFrame','sci_dbsWriteFrame','csci6'; ..
           'dbsWriteFrames','sci_dbsWriteFrames', 'csci6'; 'dbsCloseFrame','sci_dbsCloseFrame','csci6'; ..
           'dbstoreVersion','sci_dbstoreVersion', 'csci6'; ..
           'changeSite',      'sci_changeSite'       'csci6'; 'currentSite',      'sci_currentSite',       'csci6'; ..
           'retrieveOpen',    'sci_retrieveOpen',    'csci6'; 'retrieveShotInfo', 'sci_retrieveShotInfo',  'csci6'; ..
           'retrieveClose',   'sci_retrieveClose',   'csci6'; 'retrieveChInfo',   'sci_retrieveChInfo',    'csci6'; ..
           'retrieveChInfo2', 'sci_retrieveChInfo2', 'csci6'; 'retrieveChData',   'sci_retrieveChData',    'csci6'; ..
           'retrieveChV',     'sci_retrieveChV',     'csci6'; 'retrieveChParam',  'sci_retrieveChParam',   'csci6'; ..
           'retrieveChParams',   'sci_retrieveChParams',   'csci6'; 'retrieveRetrieveNo','sci_retrieveRetrieveNo',     'csci6'; ..
           'retrieveFrameData',  'sci_retrieveFrameData',  'csci6'; 'retrieveFrameInfo', 'sci_retrieveFrameInfo',      'csci6'; ..
           'retrieveChFrameData','sci_retrieveChFrameData','csci6'; 'retrieveVersion',   'sci_retrieveVersion',        'csci6'; ..
           'retrieveTimeData',   'sci_retrieveTimeData'  , 'csci6'; 'retrieveTimeInfo',  'sci_retrieveTimeInfo',       'csci6'; ..
           'rGetDTSinfox',      'sci_retrieveGetDTSinfox', 'csci6'; 'rGetDTSdatax2',     'sci_retrieveGetDTSdatax2_ex','csci6'; ..
           'rGetDTSinfoFromRetrieve','sci_retrieveGetDTSinfoFromRetrieve_ex','csci6'; ..
           'rGetDTSParametersCount', 'sci_retrieveGetDTSParametersCount',    'csci6'; ..
           'rGetDTSParameters',      'sci_retrieveGetDTSParameters',         'csci6'; ..
           'retrieveMessage',   'sci_retrieveMessage',        'csci6'; 'dbsMessage',   'sci_dbsMessage',        'csci6'; ..
           'var2str',      'sci_var2str',         'csci6'; 'str2var',      'sci_str2var',         'csci6'];

    // includes_src_c = ilib_include_flag(get_absolute_file_path("builder_gateway_cpp.sce") + "../../src/c");
    [vs,opt] = getversion();
    if 'Windows' == getos() then
      cflags = '-Ic:\labcom\retrieve\include -DWIN32';
      if 'x64' == opt(2) then
        lflags = '-LIBPATH:C:\LABCOM\Retrieve\win_sdk\lib64 Retrieve.lib  dbstoredll.lib';
      else
        lflags = '-LIBPATH:C:\LABCOM\Retrieve\win_sdk\lib Retrieve.lib  dbstoredll.lib';
      end
      libs   = [];
    else
      retrieve_home = getenv('Retrieve');
      inc_path = [retrieve_home+'/include';get_absolute_file_path("builder_gateway_cpp.sce")];
      cflags = ilib_include_flag(inc_path);
      lflags   = [];
      if 'x64' == opt(2) then
        libs   = [retrieve_home+'/bin64/libretrieve' retrieve_home+'/bin64/libdbstore'];
      else
        libs   = [retrieve_home+'/bin/libretrieve' retrieve_home+'/bin/libdbstore'];
      end
    end
    //adapt to compiler capabilities
    l = ilib_language();
    if ~isempty(grep(l, "csci6")) then
        tbx_build_gateway("sci_labcomrd", funcs, files,  ..
            get_absolute_file_path("builder_gateway_cpp.sce"), ..
            libs, lflags, cflags);
    end
endfunction

builder_gw_cpp();
clear builder_gw_cpp; // remove builder_gw_cpp on stack
